unit jsonU;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.Controls.Presentation, FMX.ScrollBox, FMX.Memo;

type
  TMainForm = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Memo2: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    function getcoupons(const ptext :String) : String;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.fmx}

uses System.JSON;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  getcoupons(memo1.text);
end;


function TMainForm.getcoupons(const ptext: String): String;
var
  JSonValue: TJSonValue;
  JsonArray, Detail : TJSONArray;
  ArrayElement,DetailElement,DisplayValue: TJSonValue;
  V : String;
begin
  try
  memo2.Lines.Clear;
  // Parse le texte
  JsonValue := TJSonObject.ParseJSONValue(pText);
  if JSONValue.TryGetValue<String>('id',v) then memo2.Lines.Add('id : '+v);

  // Obtention des coupons (array)
  if JSONValue.TryGetValue<TJSONArray>('coupon_lines',JsonArray) then
  begin
     for ArrayElement in JsonArray do begin
      memo2.Lines.Add('code : '+ArrayElement.GetValue<String>('code') );
      memo2.Lines.Add('remise : '+ ArrayElement.GetValue<String>('discount'));
      // Obtention dtails d'un coupon
      if ArrayElement.TryGetValue<TJSONArray>('meta_data',Detail) then
       begin
         for DetailElement in Detail do
         begin
          // Dtails  afficher
          if DetailElement.TryGetValue<TJSONValue>('display_value',DisplayValue) then
           begin
              if DisplayValue.TryGetValue<String>('discount_type',v) then
              memo2.Lines.Add('type : '+v );
              if DisplayValue.TryGetValue<String>('description',v) then
              memo2.Lines.Add('description : '+ v);
            end;
         end;
       end;
    end;
  end;
  finally
//    DisplayValue.Free;
//    ArrayElement.Free;
//    DetailElement.Free;
//    FreeAndNil(JsonArray);

  end;
end;

initialization
ReportMemoryLeaksOnShutdown:=true;

end.
